## AgsFMSynthUtil

AgsFMSynthUtil — frequency modulation synth util

## Stability Level

Stable, unless otherwise indicated

## Functions

AgsFMSynthUtil * | ags_fm_synth_util_alloc ()
gpointer | ags_fm_synth_util_copy ()
void | ags_fm_synth_util_free ()
gpointer | ags_fm_synth_util_get_source ()
void | ags_fm_synth_util_set_source ()
guint | ags_fm_synth_util_get_source_stride ()
void | ags_fm_synth_util_set_source_stride ()
guint | ags_fm_synth_util_get_buffer_length ()
void | ags_fm_synth_util_set_buffer_length ()
AgsSoundcardFormat | ags_fm_synth_util_get_format ()
void | ags_fm_synth_util_set_format ()
guint | ags_fm_synth_util_get_samplerate ()
void | ags_fm_synth_util_set_samplerate ()
guint | ags_fm_synth_util_get_synth_oscillator_mode ()
void | ags_fm_synth_util_set_synth_oscillator_mode ()
gdouble | ags_fm_synth_util_get_frequency ()
void | ags_fm_synth_util_set_frequency ()
gdouble | ags_fm_synth_util_get_phase ()
void | ags_fm_synth_util_set_phase ()
gdouble | ags_fm_synth_util_get_volume ()
void | ags_fm_synth_util_set_volume ()
guint | ags_fm_synth_util_get_lfo_oscillator_mode ()
void | ags_fm_synth_util_set_lfo_oscillator_mode ()
gdouble | ags_fm_synth_util_get_lfo_frequency ()
void | ags_fm_synth_util_set_lfo_frequency ()
gdouble | ags_fm_synth_util_get_lfo_depth ()
void | ags_fm_synth_util_set_lfo_depth ()
gdouble | ags_fm_synth_util_get_tuning ()
void | ags_fm_synth_util_set_tuning ()
guint | ags_fm_synth_util_get_frame_count ()
void | ags_fm_synth_util_set_frame_count ()
guint | ags_fm_synth_util_get_offset ()
void | ags_fm_synth_util_set_offset ()
gboolean | ags_fm_synth_util_get_note_256th_mode ()
void | ags_fm_synth_util_set_note_256th_mode ()
guint | ags_fm_synth_util_get_offset_256th ()
void | ags_fm_synth_util_set_offset_256th ()
void | ags_fm_synth_util_compute_sin_s8 ()
void | ags_fm_synth_util_compute_sin_s16 ()
void | ags_fm_synth_util_compute_sin_s24 ()
void | ags_fm_synth_util_compute_sin_s32 ()
void | ags_fm_synth_util_compute_sin_s64 ()
void | ags_fm_synth_util_compute_sin_float ()
void | ags_fm_synth_util_compute_sin_double ()
void | ags_fm_synth_util_compute_sin_complex ()
void | ags_fm_synth_util_compute_sin ()
void | ags_fm_synth_util_compute_sawtooth_s8 ()
void | ags_fm_synth_util_compute_sawtooth_s16 ()
void | ags_fm_synth_util_compute_sawtooth_s24 ()
void | ags_fm_synth_util_compute_sawtooth_s32 ()
void | ags_fm_synth_util_compute_sawtooth_s64 ()
void | ags_fm_synth_util_compute_sawtooth_float ()
void | ags_fm_synth_util_compute_sawtooth_double ()
void | ags_fm_synth_util_compute_sawtooth_complex ()
void | ags_fm_synth_util_compute_sawtooth ()
void | ags_fm_synth_util_compute_triangle_s8 ()
void | ags_fm_synth_util_compute_triangle_s16 ()
void | ags_fm_synth_util_compute_triangle_s24 ()
void | ags_fm_synth_util_compute_triangle_s32 ()
void | ags_fm_synth_util_compute_triangle_s64 ()
void | ags_fm_synth_util_compute_triangle_float ()
void | ags_fm_synth_util_compute_triangle_double ()
void | ags_fm_synth_util_compute_triangle_complex ()
void | ags_fm_synth_util_compute_triangle ()
void | ags_fm_synth_util_compute_square_s8 ()
void | ags_fm_synth_util_compute_square_s16 ()
void | ags_fm_synth_util_compute_square_s24 ()
void | ags_fm_synth_util_compute_square_s32 ()
void | ags_fm_synth_util_compute_square_s64 ()
void | ags_fm_synth_util_compute_square_float ()
void | ags_fm_synth_util_compute_square_double ()
void | ags_fm_synth_util_compute_square_complex ()
void | ags_fm_synth_util_compute_square ()
void | ags_fm_synth_util_compute_impulse_s8 ()
void | ags_fm_synth_util_compute_impulse_s16 ()
void | ags_fm_synth_util_compute_impulse_s24 ()
void | ags_fm_synth_util_compute_impulse_s32 ()
void | ags_fm_synth_util_compute_impulse_s64 ()
void | ags_fm_synth_util_compute_impulse_float ()
void | ags_fm_synth_util_compute_impulse_double ()
void | ags_fm_synth_util_compute_impulse_complex ()
void | ags_fm_synth_util_compute_impulse ()

## Types and Values

#define | AGS_FM_SYNTH_UTIL_DEFAULT_FREQUENCY
#define | AGS_FM_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY
#define | AGS_FM_SYNTH_UTIL_DEFAULT_LFO_DEPTH
#define | AGS_FM_SYNTH_UTIL_DEFAULT_TUNING
#define | AGS_FM_SYNTH_UTIL_INITIALIZER

## Object Hierarchy

        GBoxed
        ╰── AgsFMSynthUtil

## Includes

    #include <ags/audio/ags_fm_synth_util.h>

## Description

Utility functions to compute FM synths.

## Functions

### ags_fm_synth_util_alloc ()

    AgsFMSynthUtil *
    ags_fm_synth_util_alloc ();

Allocate AgsFMSynthUtil

#### Returns

a new AgsFMSynthUtil

Since: 3.9.3

### ags_fm_synth_util_copy ()

    gpointer
    ags_fm_synth_util_copy (AgsFMSynthUtil *ptr);

Create a copy of `ptr` .

#### Parameters

ptr | the original AgsFMSynthUtil |

#### Returns

a pointer of the new AgsFMSynthUtil

Since: 3.9.3

### ags_fm_synth_util_free ()

    void
    ags_fm_synth_util_free (AgsFMSynthUtil *ptr);

Free the memory of `ptr` .

#### Parameters

ptr | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_get_source ()

    gpointer
    ags_fm_synth_util_get_source (AgsFMSynthUtil *fm_synth_util);

Get source buffer of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the source buffer

Since: 3.9.3

### ags_fm_synth_util_set_source ()

    void
    ags_fm_synth_util_set_source (AgsFMSynthUtil *fm_synth_util,
                                  gpointer source);

Set `source` buffer of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
source | the source buffer. | [transfer none]

Since: 3.9.3

### ags_fm_synth_util_get_source_stride ()

    guint
    ags_fm_synth_util_get_source_stride (AgsFMSynthUtil *fm_synth_util);

Get source stride of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the source buffer stride

Since: 3.9.3

### ags_fm_synth_util_set_source_stride ()

    void
    ags_fm_synth_util_set_source_stride (AgsFMSynthUtil *fm_synth_util,
                                         guint source_stride);

Set `source` stride of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
source_stride | the source buffer stride |

Since: 3.9.3

### ags_fm_synth_util_get_buffer_length ()

    guint
    ags_fm_synth_util_get_buffer_length (AgsFMSynthUtil *fm_synth_util);

Get buffer length of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the buffer length

Since: 3.9.3

### ags_fm_synth_util_set_buffer_length ()

    void
    ags_fm_synth_util_set_buffer_length (AgsFMSynthUtil *fm_synth_util,
                                         guint buffer_length);

Set `buffer_length` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
buffer_length | the buffer length |

Since: 3.9.3

### ags_fm_synth_util_get_format ()

    AgsSoundcardFormat
    ags_fm_synth_util_get_format (AgsFMSynthUtil *fm_synth_util);

Get audio buffer util format of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the audio buffer util format

Since: 3.14.0

### ags_fm_synth_util_set_format ()

    void
    ags_fm_synth_util_set_format (AgsFMSynthUtil *fm_synth_util,
                                  AgsSoundcardFormat format);

Set `format` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
format | the audio buffer util format |

Since: 3.14.0

### ags_fm_synth_util_get_samplerate ()

    guint
    ags_fm_synth_util_get_samplerate (AgsFMSynthUtil *fm_synth_util);

Get samplerate of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the samplerate

Since: 3.9.3

### ags_fm_synth_util_set_samplerate ()

    void
    ags_fm_synth_util_set_samplerate (AgsFMSynthUtil *fm_synth_util,
                                      guint samplerate);

Set `samplerate` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
samplerate | the samplerate |

Since: 3.9.3

### ags_fm_synth_util_get_synth_oscillator_mode ()

    guint
    ags_fm_synth_util_get_synth_oscillator_mode
                                   (AgsFMSynthUtil *fm_synth_util);

Get synth oscillator mode of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the synth oscillator mode

Since: 3.9.3

### ags_fm_synth_util_set_synth_oscillator_mode ()

    void
    ags_fm_synth_util_set_synth_oscillator_mode
                                   (AgsFMSynthUtil *fm_synth_util,
                                    guint synth_oscillator_mode);

Set `synth_oscillator_mode` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
synth_oscillator_mode | the synth oscillator mode |

Since: 3.9.3

### ags_fm_synth_util_get_frequency ()

    gdouble
    ags_fm_synth_util_get_frequency (AgsFMSynthUtil *fm_synth_util);

Get frequency of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the frequency

Since: 3.9.3

### ags_fm_synth_util_set_frequency ()

    void
    ags_fm_synth_util_set_frequency (AgsFMSynthUtil *fm_synth_util,
                                     gdouble frequency);

Set `frequency` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
frequency | the frequency |

Since: 3.9.3

### ags_fm_synth_util_get_phase ()

    gdouble
    ags_fm_synth_util_get_phase (AgsFMSynthUtil *fm_synth_util);

Get phase of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the phase

Since: 3.9.3

### ags_fm_synth_util_set_phase ()

    void
    ags_fm_synth_util_set_phase (AgsFMSynthUtil *fm_synth_util,
                                 gdouble phase);

Set `phase` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
phase | the phase |

Since: 3.9.3

### ags_fm_synth_util_get_volume ()

    gdouble
    ags_fm_synth_util_get_volume (AgsFMSynthUtil *fm_synth_util);

Get volume of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the volume

Since: 3.9.3

### ags_fm_synth_util_set_volume ()

    void
    ags_fm_synth_util_set_volume (AgsFMSynthUtil *fm_synth_util,
                                  gdouble volume);

Set `volume` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
volume | the volume |

Since: 3.9.3

### ags_fm_synth_util_get_lfo_oscillator_mode ()

    guint
    ags_fm_synth_util_get_lfo_oscillator_mode
                                   (AgsFMSynthUtil *fm_synth_util);

Get LFO oscillator mode of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the LFO oscillator mode

Since: 3.9.3

### ags_fm_synth_util_set_lfo_oscillator_mode ()

    void
    ags_fm_synth_util_set_lfo_oscillator_mode
                                   (AgsFMSynthUtil *fm_synth_util,
                                    guint lfo_oscillator_mode);

Set `lfo_oscillator_mode` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
lfo_oscillator_mode | the LFO oscillator mode |

Since: 3.9.3

### ags_fm_synth_util_get_lfo_frequency ()

    gdouble
    ags_fm_synth_util_get_lfo_frequency (AgsFMSynthUtil *fm_synth_util);

Get LFO frequency of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the LFO frequency

Since: 3.9.3

### ags_fm_synth_util_set_lfo_frequency ()

    void
    ags_fm_synth_util_set_lfo_frequency (AgsFMSynthUtil *fm_synth_util,
                                         gdouble lfo_frequency);

Set `lfo_frequency` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
lfo_frequency | the LFO frequency |

Since: 3.9.3

### ags_fm_synth_util_get_lfo_depth ()

    gdouble
    ags_fm_synth_util_get_lfo_depth (AgsFMSynthUtil *fm_synth_util);

Get LFO depth of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the LFO depth

Since: 3.9.3

### ags_fm_synth_util_set_lfo_depth ()

    void
    ags_fm_synth_util_set_lfo_depth (AgsFMSynthUtil *fm_synth_util,
                                     gdouble lfo_depth);

Set `lfo_depth` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
lfo_depth | the LFO depth |

Since: 3.9.3

### ags_fm_synth_util_get_tuning ()

    gdouble
    ags_fm_synth_util_get_tuning (AgsFMSynthUtil *fm_synth_util);

Get tuning of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the tuning

Since: 3.9.3

### ags_fm_synth_util_set_tuning ()

    void
    ags_fm_synth_util_set_tuning (AgsFMSynthUtil *fm_synth_util,
                                  gdouble tuning);

Set `tuning` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
tuning | the tuning |

Since: 3.9.3

### ags_fm_synth_util_get_frame_count ()

    guint
    ags_fm_synth_util_get_frame_count (AgsFMSynthUtil *fm_synth_util);

Get frame count of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the frame count

Since: 3.9.3

### ags_fm_synth_util_set_frame_count ()

    void
    ags_fm_synth_util_set_frame_count (AgsFMSynthUtil *fm_synth_util,
                                       guint frame_count);

Set `frame_count` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
frame_count | the frame count |

Since: 3.9.3

### ags_fm_synth_util_get_offset ()

    guint
    ags_fm_synth_util_get_offset (AgsFMSynthUtil *fm_synth_util);

Get offset of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the offset

Since: 3.9.3

### ags_fm_synth_util_set_offset ()

    void
    ags_fm_synth_util_set_offset (AgsFMSynthUtil *fm_synth_util,
                                  guint offset);

Set `offset` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
offset | the offset |

Since: 3.9.3

### ags_fm_synth_util_get_note_256th_mode ()

    gboolean
    ags_fm_synth_util_get_note_256th_mode (AgsFMSynthUtil *fm_synth_util);

Get note 256th mode of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

`TRUE` if note 256th mode, otherwise `FALSE`

Since: 6.1.0

### ags_fm_synth_util_set_note_256th_mode ()

    void
    ags_fm_synth_util_set_note_256th_mode (AgsFMSynthUtil *fm_synth_util,
                                           gboolean note_256th_mode);

Set `note_256th_mode` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
note_256th_mode | the note 256th mode |

Since: 6.1.0

### ags_fm_synth_util_get_offset_256th ()

    guint
    ags_fm_synth_util_get_offset_256th (AgsFMSynthUtil *fm_synth_util);

Get offset as note 256th of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

#### Returns

the offset as note 256th

Since: 6.1.0

### ags_fm_synth_util_set_offset_256th ()

    void
    ags_fm_synth_util_set_offset_256th (AgsFMSynthUtil *fm_synth_util,
                                        guint offset_256th);

Set `offset_256th` of `fm_synth_util` .

#### Parameters

fm_synth_util | the AgsFMSynthUtil |
offset_256th | the offset as note 256th |

Since: 6.1.0

### ags_fm_synth_util_compute_sin_s8 ()

    void
    ags_fm_synth_util_compute_sin_s8 (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of signed 8 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_s16 ()

    void
    ags_fm_synth_util_compute_sin_s16 (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of signed 16 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_s24 ()

    void
    ags_fm_synth_util_compute_sin_s24 (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of signed 24 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_s32 ()

    void
    ags_fm_synth_util_compute_sin_s32 (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of signed 32 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_s64 ()

    void
    ags_fm_synth_util_compute_sin_s64 (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of signed 64 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_float ()

    void
    ags_fm_synth_util_compute_sin_float (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_double ()

    void
    ags_fm_synth_util_compute_sin_double (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of double precision floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin_complex ()

    void
    ags_fm_synth_util_compute_sin_complex (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth of complex data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sin ()

    void
    ags_fm_synth_util_compute_sin (AgsFMSynthUtil *fm_synth_util);

Compute FM sine synth.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_s8 ()

    void
    ags_fm_synth_util_compute_sawtooth_s8 (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of signed 8 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_s16 ()

    void
    ags_fm_synth_util_compute_sawtooth_s16
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of signed 16 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_s24 ()

    void
    ags_fm_synth_util_compute_sawtooth_s24
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of signed 24 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_s32 ()

    void
    ags_fm_synth_util_compute_sawtooth_s32
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of signed 32 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_s64 ()

    void
    ags_fm_synth_util_compute_sawtooth_s64
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of signed 64 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_float ()

    void
    ags_fm_synth_util_compute_sawtooth_float
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_double ()

    void
    ags_fm_synth_util_compute_sawtooth_double
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of double precision floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth_complex ()

    void
    ags_fm_synth_util_compute_sawtooth_complex
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth of complex data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_sawtooth ()

    void
    ags_fm_synth_util_compute_sawtooth (AgsFMSynthUtil *fm_synth_util);

Compute FM sawtooth synth.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_s8 ()

    void
    ags_fm_synth_util_compute_triangle_s8 (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of signed 8 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_s16 ()

    void
    ags_fm_synth_util_compute_triangle_s16
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of signed 16 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_s24 ()

    void
    ags_fm_synth_util_compute_triangle_s24
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of signed 24 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_s32 ()

    void
    ags_fm_synth_util_compute_triangle_s32
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of signed 32 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_s64 ()

    void
    ags_fm_synth_util_compute_triangle_s64
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of signed 64 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_float ()

    void
    ags_fm_synth_util_compute_triangle_float
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_double ()

    void
    ags_fm_synth_util_compute_triangle_double
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of double precision floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle_complex ()

    void
    ags_fm_synth_util_compute_triangle_complex
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth of complex data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_triangle ()

    void
    ags_fm_synth_util_compute_triangle (AgsFMSynthUtil *fm_synth_util);

Compute FM triangle synth.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_s8 ()

    void
    ags_fm_synth_util_compute_square_s8 (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of signed 8 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_s16 ()

    void
    ags_fm_synth_util_compute_square_s16 (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of signed 16 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_s24 ()

    void
    ags_fm_synth_util_compute_square_s24 (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of signed 24 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_s32 ()

    void
    ags_fm_synth_util_compute_square_s32 (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of signed 32 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_s64 ()

    void
    ags_fm_synth_util_compute_square_s64 (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of signed 64 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_float ()

    void
    ags_fm_synth_util_compute_square_float
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_double ()

    void
    ags_fm_synth_util_compute_square_double
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of double precision floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square_complex ()

    void
    ags_fm_synth_util_compute_square_complex
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth of complex data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_square ()

    void
    ags_fm_synth_util_compute_square (AgsFMSynthUtil *fm_synth_util);

Compute FM square synth.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_s8 ()

    void
    ags_fm_synth_util_compute_impulse_s8 (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of signed 8 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_s16 ()

    void
    ags_fm_synth_util_compute_impulse_s16 (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of signed 16 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_s24 ()

    void
    ags_fm_synth_util_compute_impulse_s24 (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of signed 24 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_s32 ()

    void
    ags_fm_synth_util_compute_impulse_s32 (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of signed 32 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_s64 ()

    void
    ags_fm_synth_util_compute_impulse_s64 (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of signed 64 bit data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_float ()

    void
    ags_fm_synth_util_compute_impulse_float
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_double ()

    void
    ags_fm_synth_util_compute_impulse_double
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of double precision floating point data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse_complex ()

    void
    ags_fm_synth_util_compute_impulse_complex
                                   (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth of complex data.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

### ags_fm_synth_util_compute_impulse ()

    void
    ags_fm_synth_util_compute_impulse (AgsFMSynthUtil *fm_synth_util);

Compute FM impulse synth.

#### Parameters

fm_synth_util | the AgsFMSynthUtil |

Since: 3.9.3

## Types and Values

### AGS_FM_SYNTH_UTIL_DEFAULT_FREQUENCY

    #define AGS_FM_SYNTH_UTIL_DEFAULT_FREQUENCY (440.0)

### AGS_FM_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY

    #define AGS_FM_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY (12.0)

### AGS_FM_SYNTH_UTIL_DEFAULT_LFO_DEPTH

    #define AGS_FM_SYNTH_UTIL_DEFAULT_LFO_DEPTH (0.0)

### AGS_FM_SYNTH_UTIL_DEFAULT_TUNING

    #define AGS_FM_SYNTH_UTIL_DEFAULT_TUNING (0.0)

### AGS_FM_SYNTH_UTIL_INITIALIZER

    #define             AGS_FM_SYNTH_UTIL_INITIALIZER